Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/phytracr_spl_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/phytracr_spl_mod.F90	(revision 5098)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/phytracr_spl_mod.F90	(revision 5099)
@@ -2691,90 +2608,83 @@
 #endif
 
-
-
-!
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_end)
-      dife=clock_end-clock_start
-      ti_sedi=dife*MAX(0,SIGN(1,dife))   &
-      +(dife+clock_per_max)*MAX(0,SIGN(1,-dife))
-      tia_sedi=tia_sedi+REAL(ti_sedi)/REAL(clock_rate)
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_end)
+      dife = clock_end - clock_start
+      ti_sedi = dife * MAX(0, SIGN(1, dife))   &
+              + (dife + clock_per_max) * MAX(0, SIGN(1, -dife))
+      tia_sedi = tia_sedi + REAL(ti_sedi) / REAL(clock_rate)
+    ENDIF
+
+    DO itr = 1, nbtr
+      DO j = 1, klev
+        DO i = 1, klon
+          tmp_var(i, j) = tr_seri(i, j, itr)
+        ENDDO
+      ENDDO
+      CALL cm3_to_kg(pplay, t_seri, tmp_var)
+      DO j = 1, klev
+        DO i = 1, klon
+          tr_seri(i, j, itr) = tmp_var(i, j)
+        ENDDO
+      ENDDO
+    ENDDO
+    iscm3 = .false.
+
+
+    !======================================================================
+    !                      GAS TO PARTICLE CONVERSION
+    !======================================================================
+
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_start)
+    ENDIF
+
+    IF (lminmax) THEN
+      DO itr = 1, nbtr
+        CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_beforegastopar')
+      ENDDO
+      DO itr = 1, nbtr
+        CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'before gastopar')
+      ENDDO
+      IF (lcheckmass) THEN
+        DO itr = 1, nbtr
+          CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                  pplay, t_seri, iscm3, 'before gastopar')
+        ENDDO
       ENDIF
-
-      DO itr=1,nbtr
-         DO j=1,klev
-         DO i=1,klon
-           tmp_var(i,j)=tr_seri(i,j,itr)
-         ENDDO 
-         ENDDO
-         CALL cm3_to_kg(pplay,t_seri,tmp_var)
-         DO j=1,klev
-         DO i=1,klon
-           tr_seri(i,j,itr)=tmp_var(i,j)
-         ENDDO 
-         ENDDO
-      ENDDO
-      iscm3=.false.
-!
-!
-!======================================================================
-!                      GAS TO PARTICLE CONVERSION      
-!======================================================================
-!
-
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_start)
+      CALL minmaxsource(source_tr, qmin, qmax, 'src: before gastopar')
+    ENDIF
+
+    CALL gastoparticle(pdtphys, zdz, zrho, rlat, &
+            pplay, t_seri, id_prec, id_fine, &
+            tr_seri, his_g2pgas, his_g2paer)
+
+    IF (lminmax) THEN
+      DO itr = 1, nbtr
+        CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_after_gastopar')
+      ENDDO
+      DO itr = 1, nbtr
+        CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'after gastopar')
+      ENDDO
+      IF (lcheckmass) THEN
+        DO itr = 1, nbtr
+          CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                  pplay, t_seri, iscm3, 'after gastopar')
+        ENDDO
       ENDIF
-
-      IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_beforegastopar')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'before gastopar')
-        ENDDO
-      IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,  &
-           pplay,t_seri,iscm3,'before gastopar')
-        ENDDO
-      ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'src: before gastopar')
-      ENDIF
-
-      CALL gastoparticle(pdtphys,zdz,zrho,rlat, &
-                   pplay,t_seri,id_prec,id_fine, &
-                   tr_seri,his_g2pgas ,his_g2paer) 
-!
-      IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_after_gastopar')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'after gastopar')
-        ENDDO
-      IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,  &
-           pplay,t_seri,iscm3,'after gastopar')
-        ENDDO
-       ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'src: after gastopar')
-      ENDIF
-
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_end)
-      dife=clock_end-clock_start
-      ti_gasp=dife*MAX(0,SIGN(1,dife))   &
-      +(dife+clock_per_max)*MAX(0,SIGN(1,-dife))
-      tia_gasp=tia_gasp+REAL(ti_gasp)/REAL(clock_rate)
-      ENDIF
-
-
-!
-!======================================================================
-!          EFFECT OF PRECIPITATION: iflag_conv=2
-!======================================================================
-!
+      CALL minmaxsource(source_tr, qmin, qmax, 'src: after gastopar')
+    ENDIF
+
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_end)
+      dife = clock_end - clock_start
+      ti_gasp = dife * MAX(0, SIGN(1, dife))   &
+              + (dife + clock_per_max) * MAX(0, SIGN(1, -dife))
+      tia_gasp = tia_gasp + REAL(ti_gasp) / REAL(clock_rate)
+    ENDIF
+
+    !======================================================================
+    !          EFFECT OF PRECIPITATION: iflag_conv=2
+    !======================================================================
 
 #ifdef IOPHYS_DUST
@@ -2786,171 +2696,161 @@
 
 
-      IF (iflag_conv==2) THEN
+    IF (iflag_conv==2) THEN
 
       IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_start)
+        CALL SYSTEM_CLOCK(COUNT = clock_start)
       ENDIF
 
-
-
-
-       DO itr=1,nbtr
-        DO j=1,klev
-        DO i=1,klon
-           tmp_var(i,j)=tr_seri(i,j,itr)
-        ENDDO
-        ENDDO
-        CALL kg_to_cm3(pplay,t_seri,tmp_var)
-        DO j=1,klev
-        DO i=1,klon
-           tr_seri(i,j,itr)=tmp_var(i,j)
-        ENDDO
-        ENDDO
-      ENDDO
-       iscm3=.true.
-!------------------------------
-
-      print *,'iflag_conv bef lessiv',iflag_conv
+      DO itr = 1, nbtr
+        DO j = 1, klev
+          DO i = 1, klon
+            tmp_var(i, j) = tr_seri(i, j, itr)
+          ENDDO
+        ENDDO
+        CALL kg_to_cm3(pplay, t_seri, tmp_var)
+        DO j = 1, klev
+          DO i = 1, klon
+            tr_seri(i, j, itr) = tmp_var(i, j)
+          ENDDO
+        ENDDO
+      ENDDO
+      iscm3 = .true.
+      !------------------------------
+
+      print *, 'iflag_conv bef lessiv', iflag_conv
       IF (lessivage) THEN
-!
-      print *,' BEFORE Incloud'
-
-      IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_before_incloud')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'before incloud')
-        ENDDO
-      IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,  &
-           pplay,t_seri,iscm3,'before incloud')
-        ENDDO
+
+        print *, ' BEFORE Incloud'
+
+        IF (lminmax) THEN
+          DO itr = 1, nbtr
+            CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_before_incloud')
+          ENDDO
+          DO itr = 1, nbtr
+            CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'before incloud')
+          ENDDO
+          IF (lcheckmass) THEN
+            DO itr = 1, nbtr
+              CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                      pplay, t_seri, iscm3, 'before incloud')
+            ENDDO
+          ENDIF
+          CALL minmaxsource(source_tr, qmin, qmax, 'src: before incloud')
+        ENDIF
+
+
+        !      CALL incloud_scav(lminmax,qmin,qmax,masse,henry,kk,prfl,
+        !     .                  psfl,pmflxr,pmflxs,zrho,zdz,t_seri,pdtphys,
+
+        !     .                                     his_dhlsc,his_dhcon,tr_seri)
+        print *, 'iflag_conv bef incloud', iflag_conv
+
+        IF (iflag_conv==2) THEN
+          ! Tiedke
+          CALL incloud_scav(.false., qmin, qmax, masse, henry, kk, prfl, &
+                  psfl, pmflxr, pmflxs, zrho, zdz, t_seri, pdtphys, &
+                  his_dhlsc, his_dhcon, tr_seri)
+
+          !---------- to use this option please comment lsc_scav at the end
+          !        ELSE IF (iflag_conv.GE.3) THEN
+
+          !      CALL incloud_scav_lsc(.false.,qmin,qmax,masse,henry,kk,prfl,
+          !     .                  psfl,pmflxr,pmflxs,zrho,zdz,t_seri,pdtphys,
+          !     .                                     his_dhlsc,his_dhcon,tr_seri)
+          !--------------------------------------------------------------
+
+        ENDIF
+
+        print *, ' BEFORE blcloud (after incloud)'
+        IF (lminmax) THEN
+          DO itr = 1, nbtr
+            CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_before_blcloud')
+          ENDDO
+          DO itr = 1, nbtr
+            CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'before blcloud')
+          ENDDO
+          IF (lcheckmass) THEN
+            DO itr = 1, nbtr
+              CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                      pplay, t_seri, iscm3, 'before blcloud')
+            ENDDO
+          ENDIF
+          CALL minmaxsource(source_tr, qmin, qmax, 'src: before blcloud')
+        ENDIF
+
+        !      CALL blcloud_scav(lminmax,qmin,qmax,pdtphys,prfl,psfl,
+        !     .                  pmflxr,pmflxs,zdz,alpha_r,alpha_s,masse,
+        !     .                                  his_dhbclsc,his_dhbccon,tr_seri)
+
+        IF (iflag_conv==2) THEN
+          ! Tiedke
+
+          CALL blcloud_scav(.false., qmin, qmax, pdtphys, prfl, psfl, &
+                  pmflxr, pmflxs, zdz, alpha_r, alpha_s, masse, &
+                  his_dhbclsc, his_dhbccon, tr_seri)
+
+          !---------- to use this option please comment lsc_scav at the end
+          !           and comment IF iflag=2 after "EFFECT OF PRECIPITATION:"
+
+
+          !        ELSE IF (iflag_conv.GE.3) THEN
+
+          !      CALL blcloud_scav_lsc(.false.,qmin,qmax,pdtphys,prfl,psfl,
+          !     .                  pmflxr,pmflxs,zdz,alpha_r,alpha_s,masse,
+          !     .                                  his_dhbclsc,his_dhbccon,tr_seri)
+
+          !----------------------------------------------------------------------
+        ENDIF
+
+        print *, ' AFTER blcloud '
+
+        IF (lminmax) THEN
+          DO itr = 1, nbtr
+            CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_after_blcloud')
+          ENDDO
+          DO itr = 1, nbtr
+            CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'after blcloud')
+          ENDDO
+          IF (lcheckmass) THEN
+            DO itr = 1, nbtr
+              CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                      pplay, t_seri, iscm3, 'after blcloud')
+            ENDDO
+          ENDIF
+          CALL minmaxsource(source_tr, qmin, qmax, 'src: after blcloud')
+        ENDIF
+
+      ENDIF !--lessivage
+
+      DO itr = 1, nbtr
+        DO j = 1, klev
+          DO i = 1, klon
+            tmp_var(i, j) = tr_seri(i, j, itr)
+          ENDDO
+        ENDDO
+        CALL cm3_to_kg(pplay, t_seri, tmp_var)
+        DO j = 1, klev
+          DO i = 1, klon
+            tr_seri(i, j, itr) = tmp_var(i, j)
+          ENDDO
+        ENDDO
+      ENDDO
+      iscm3 = .false.
+
+      IF (logitime) THEN
+        CALL SYSTEM_CLOCK(COUNT = clock_end)
+        dife = clock_end - clock_start
+        ti_wetap = dife * MAX(0, SIGN(1, dife))    &
+                + (dife + clock_per_max) * MAX(0, SIGN(1, -dife))
+        tia_wetap = tia_wetap + REAL(ti_wetap) / REAL(clock_rate)
       ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'src: before incloud')
-      ENDIF
-
-
-!      CALL incloud_scav(lminmax,qmin,qmax,masse,henry,kk,prfl,
-!     .                  psfl,pmflxr,pmflxs,zrho,zdz,t_seri,pdtphys,
-
-!     .                                     his_dhlsc,his_dhcon,tr_seri)
-      print *,'iflag_conv bef incloud',iflag_conv
-
-        IF (iflag_conv==2) THEN
-! Tiedke
-      CALL incloud_scav(.false.,qmin,qmax,masse,henry,kk,prfl,          &
-                       psfl,pmflxr,pmflxs,zrho,zdz,t_seri,pdtphys,     &
-                                          his_dhlsc,his_dhcon,tr_seri)
-
-!---------- to use this option please comment lsc_scav at the end
-!        ELSE IF (iflag_conv.GE.3) THEN
-!
-!      CALL incloud_scav_lsc(.false.,qmin,qmax,masse,henry,kk,prfl,
-!     .                  psfl,pmflxr,pmflxs,zrho,zdz,t_seri,pdtphys,
-!     .                                     his_dhlsc,his_dhcon,tr_seri)
-!--------------------------------------------------------------
-
-        ENDIF
-!
-!
-      print *,' BEFORE blcloud (after incloud)'
-      IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_before_blcloud')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'before blcloud')
-        ENDDO
-      IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,   &
-           pplay,t_seri,iscm3,'before blcloud')
-        ENDDO
-      ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'src: before blcloud')
-      ENDIF
-
-!      CALL blcloud_scav(lminmax,qmin,qmax,pdtphys,prfl,psfl,
-!     .                  pmflxr,pmflxs,zdz,alpha_r,alpha_s,masse,
-!     .                                  his_dhbclsc,his_dhbccon,tr_seri)
-
-        IF (iflag_conv==2) THEN
-! Tiedke
-
-      CALL blcloud_scav(.false.,qmin,qmax,pdtphys,prfl,psfl,     &
-                       pmflxr,pmflxs,zdz,alpha_r,alpha_s,masse,  &
-                                       his_dhbclsc,his_dhbccon,tr_seri)
-
-!---------- to use this option please comment lsc_scav at the end
-!           and comment IF iflag=2 after "EFFECT OF PRECIPITATION:"
-!        
-!
-!        ELSE IF (iflag_conv.GE.3) THEN
-!
-!      CALL blcloud_scav_lsc(.false.,qmin,qmax,pdtphys,prfl,psfl,
-!     .                  pmflxr,pmflxs,zdz,alpha_r,alpha_s,masse,
-!     .                                  his_dhbclsc,his_dhbccon,tr_seri)
-!
-!----------------------------------------------------------------------
-        ENDIF
-
-
-      print *,' AFTER blcloud '
-
-      IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_after_blcloud')
-        ENDDO                           
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'after blcloud')
-        ENDDO                                  
-      IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,  &
-           pplay,t_seri,iscm3,'after blcloud')
-        ENDDO
-      ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'src: after blcloud')
-      ENDIF
-
-
-      ENDIF !--lessivage
-
-      DO itr=1,nbtr
-         DO j=1,klev
-         DO i=1,klon
-           tmp_var(i,j)=tr_seri(i,j,itr)
-         ENDDO 
-         ENDDO
-         CALL cm3_to_kg(pplay,t_seri,tmp_var)
-         DO j=1,klev
-         DO i=1,klon
-           tr_seri(i,j,itr)=tmp_var(i,j)
-         ENDDO 
-         ENDDO
-      ENDDO
-       iscm3=.false.
-!
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_end)
-      dife=clock_end-clock_start
-      ti_wetap=dife*MAX(0,SIGN(1,dife))    &
-      +(dife+clock_per_max)*MAX(0,SIGN(1,-dife))
-      tia_wetap=tia_wetap+REAL(ti_wetap)/REAL(clock_rate)
-      ENDIF
-
-
-
-
-      ENDIF ! iflag_conv=2
-
-!
-!
-!======================================================================
-!                         EFFECT OF CONVECTION 
-!======================================================================
-!
+
+    ENDIF ! iflag_conv=2
+
+
+    !======================================================================
+    !                         EFFECT OF CONVECTION
+    !======================================================================
+
 #ifdef IOPHYS_DUST
       do itr=1,nbtr
@@ -2961,179 +2861,175 @@
 
 
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_start)
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_start)
+    ENDIF
+
+    IF (convection) THEN
+
+      print *, ' BEFORE trconvect'
+
+      IF (lminmax) THEN
+        DO itr = 1, nbtr
+          CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_before_trconve')
+        ENDDO
+        DO itr = 1, nbtr
+          CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'before trconve')
+        ENDDO
+        IF (lcheckmass) THEN
+          DO itr = 1, nbtr
+            CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                    pplay, t_seri, iscm3, 'before trconve')
+          ENDDO
+        ENDIF
+        CALL minmaxsource(source_tr, qmin, qmax, 'src: before trconve')
       ENDIF
 
 
-      IF (convection) THEN
-!
-      print *,' BEFORE trconvect'
-
+      ! JE        CALL trconvect(pplay,t_seri,pdtphys,pmfu,pmfd,pen_u,pde_u,
+      !     .             pen_d,pde_d,paprs,zdz,xconv,qmin,qmax,lminmax,masse,
+      !     .                                                 dtrconv,tr_seri)
+      ! -------------------------------------------------------------
+      IF (iflag_conv==2) THEN
+        ! Tiedke
+        CALL trconvect(pplay, t_seri, pdtphys, pmfu, pmfd, pen_u, pde_u, &
+                pen_d, pde_d, paprs, zdz, xconv, qmin, qmax, .false., masse, &
+                dtrconv, tr_seri)
+        DO itr = 1, nbtr
+          d_tr_cv(:, :, itr) = 0.
+        ENDDO
+
+      ELSE IF (iflag_conv>=3) THEN
+        ! KE
+        print *, 'JE: KE in phytracr_spl'
+        DO itr = 1, nbtr
+          DO k = 1, klev
+            DO i = 1, klon
+              tmp_var3(i, k, itr) = tr_seri(i, k, itr)
+            END DO
+          END DO
+        ENDDO
+
+        DO itr = 1, nbtr
+          !          routine for aerosols . otherwise, check cvltrorig
+          print *, 'Check sum before cvltr itr)', itr, SUM(tr_seri(:, :, itr))
+          !           IF (.FALSE.) THEN
+          CALL cvltr_spl(pdtphys, da, phi, phi2, d1a, dam, mp, ep, &
+                  sigd, sij, wght_cvfd, clw, elij, epmlmMm, eplaMm, &
+                  pmflxr, pmflxs, evapls, t_seri, wdtrainA, wdtrainM, &
+                  !            paprs,itr,tr_seri,upwd,dnwd,itop_con,ibas_con,        &
+                  paprs, itr, tmp_var3, upwd, dnwd, itop_con, ibas_con, &
+                  henry, kk, zrho, ccntrAA_spla, ccntrENV_spla, coefcoli_spla, &
+                  id_prec, id_fine, id_coss, id_codu, id_scdu, &
+                  d_tr_cv, d_tr_trsp, d_tr_sscav, d_tr_sat, d_tr_uscav, qDi, qPr, &
+                  qPa, qMel, qTrdi, dtrcvMA, Mint, &
+                  zmfd1a, zmfphi2, zmfdam)
+          !           ENDIF
+
+          !           IF (.FALSE.) THEN
+          !           CALL cvltr(pdtphys, da, phi,phi2,d1a,dam, mp,ep,
+          !     .       sigd,sij,wght_cvfd,clw,elij,epmlmMm,eplaMm,
+          !     .       pmflxr,pmflxs,evapls,t_seri,wdtrainA,wdtrainM,
+          !     .       paprs,itr,tmp_var3,upwd,dnwd,itop_con,ibas_con,
+          !     .       d_tr_cv,d_tr_trsp,d_tr_sscav,d_tr_sat,d_tr_uscav,qDi,qPr,
+          !     .       qPa,qMel,qTrdi,dtrcvMA,Mint,
+          !     .       zmfd1a,zmfphi2,zmfdam)
+          !!  pas lessivage convectif pou n'est pas un aerosol (i/else with cvltr)
+          !           ENDIF
+
+
+
+          !!!!!!!         CALL cvltrorig(it,pdtphys, da, phi,mp,paprs,pplay,tr_seri,
+          !!!         CALL cvltrorig(it,pdtphys, da, phi,mp,paprs,pplay,tmp_var3,
+          !!!     .               upwd,dnwd,d_tr_cv)
+          !             print *,'justbefore cvltrnoscav it= ',it
+          !             CALL checknanqfi(da(:,:),1.,-1.,' da')
+          !             CALL checknanqfi(wght_cvfd(:,:),1.,-1.,'weigth ')
+          !             CALL checknanqfi(mp(:,:),1.,-1.,'mp ')
+          !             CALL checknanqfi(paprs(:,:),1.,-1.,'paprs ')
+          !             CALL checknanqfi(pplay(:,:),1.,-1.,'pplay ')
+          !             CALL checknanqfi(tmp_var3(:,:,itr),1.,-1.,'tmp_var3 ')
+          !             CALL checknanqfi(upwd(:,:),1.,-1.,'upwd ')
+          !             CALL checknanqfi(dnwd(:,:),1.,-1.,'dnwd ')
+          !             CALL checknanqfi(d_tr_cv(:,:,itr),1.,-1.,'d_tr_cv ')
+          !             IF (.TRUE.) THEN
+          !             CALL cvltr_noscav(it,pdtphys, da, phi,mp,wght_cvfd,paprs,
+          !     .            pplay,tmp_var3,upwd,dnwd,d_tr_cv)
+          !             ENDIF
+          DO k = 1, klev
+            DO i = 1, klon
+              !               tr_seri(i,k,itr) = tr_seri(i,k,itr) + d_tr_cv(i,k,itr)
+              tr_seri(i, k, itr) = (tmp_var3(i, k, itr) + d_tr_cv(i, k, itr))
+              tmp_var(i, k) = d_tr_cv(i, k, itr)
+
+            END DO
+          END DO
+
+          CALL kg_to_cm3(pplay, t_seri, tmp_var) !just for his_* computation
+
+          DO k = 1, klev
+            DO i = 1, klon
+              dtrconv(i, itr) = 0.0
+              his_dhkecv(i, itr) = his_dhkecv(i, itr) - tmp_var(i, k)  &
+                      / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+            END DO
+          END DO
+
+          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+          CALL kg_to_cm3(pplay, t_seri, tmp_var) !just for his_* computation
+
+          DO k = 1, klev
+            DO i = 1, klon
+              dtrconv(i, itr) = 0.0
+              his_ds(i, itr) = his_ds(i, itr) - tmp_var(i, k)  &
+                      / RNAVO * masse(itr) * 1.e3 * 1.e6 * zdz(i, k) / pdtphys
+            END DO
+          END DO
+          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+          IF (lminmax) THEN
+
+            print *, 'Check sum after cvltr itr)', itr, SUM(tr_seri(:, :, itr))
+            CALL minmaxqfi2(d_tr_cv(:, :, itr), qmin, qmax, 'd_tr_cv:')
+            CALL minmaxqfi2(d_tr_trsp(:, :, itr), qmin, qmax, 'd_tr_trsp:')
+            CALL minmaxqfi2(d_tr_sscav(:, :, itr), qmin, qmax, 'd_tr_sscav:')
+            CALL minmaxqfi2(d_tr_sat(:, :, itr), qmin, qmax, 'd_tr_sat:')
+            CALL minmaxqfi2(d_tr_uscav(:, :, itr), qmin, qmax, 'd_tr_uscav:')
+            IF (lcheckmass) THEN
+              CALL checkmass(d_tr_cv(:, :, itr), RNAVO, masse(itr), zdz, &
+                      pplay, t_seri, .false., 'd_tr_cv:')
+            ENDIF
+          ENDIF
+        ENDDO ! it=1,nbtr
+
+      ENDIF ! iflag_conv
       IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_before_trconve')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'before trconve')
-        ENDDO
-      IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz,  &
-           pplay,t_seri,iscm3,'before trconve')
-        ENDDO
+        DO itr = 1, nbtr
+          CALL checknanqfi(tr_seri(:, :, itr), qmin, qmax, 'nan_after_trcon')
+        ENDDO
+        DO itr = 1, nbtr
+          CALL minmaxqfi2(tr_seri(:, :, itr), qmin, qmax, 'after trconv')
+        ENDDO
+        IF (lcheckmass) THEN
+          DO itr = 1, nbtr
+            CALL checkmass(tr_seri(:, :, itr), RNAVO, masse(itr), zdz, &
+                    pplay, t_seri, iscm3, 'after trconv')
+          ENDDO
+        ENDIF
+        CALL minmaxsource(source_tr, qmin, qmax, 'src: after trconv')
       ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'src: before trconve')
-      ENDIF
-
-
-! JE        CALL trconvect(pplay,t_seri,pdtphys,pmfu,pmfd,pen_u,pde_u,
-!     .             pen_d,pde_d,paprs,zdz,xconv,qmin,qmax,lminmax,masse,
-!     .                                                 dtrconv,tr_seri)
-! -------------------------------------------------------------     
-        IF (iflag_conv==2) THEN
-! Tiedke
-         CALL trconvect(pplay,t_seri,pdtphys,pmfu,pmfd,pen_u,pde_u,  &
-                  pen_d,pde_d,paprs,zdz,xconv,qmin,qmax,.false.,masse, &
-                                                      dtrconv,tr_seri)
-         DO itr=1,nbtr
-           d_tr_cv(:,:,itr)=0.
-         ENDDO
-
-        ELSE IF (iflag_conv>=3) THEN
-! KE
-         print *,'JE: KE in phytracr_spl'
-         DO itr=1,nbtr
-             DO k = 1, klev
-              DO i = 1, klon
-               tmp_var3(i,k,itr)=tr_seri(i,k,itr)
-              END DO
-             END DO
-         ENDDO
-
-         DO itr=1,nbtr
-!          routine for aerosols . otherwise, check cvltrorig
-         print *,'Check sum before cvltr itr)',itr,SUM(tr_seri(:,:,itr))
-!           IF (.FALSE.) THEN 
-           CALL cvltr_spl(pdtphys, da, phi,phi2,d1a,dam, mp,ep,    &
-            sigd,sij,wght_cvfd,clw,elij,epmlmMm,eplaMm,           &
-            pmflxr,pmflxs,evapls,t_seri,wdtrainA,wdtrainM,          &
-!            paprs,itr,tr_seri,upwd,dnwd,itop_con,ibas_con,        &
-            paprs,itr,tmp_var3,upwd,dnwd,itop_con,ibas_con,        &
-            henry,kk,zrho,ccntrAA_spla,ccntrENV_spla,coefcoli_spla, &
-            id_prec,id_fine,id_coss, id_codu, id_scdu,              &
-            d_tr_cv,d_tr_trsp,d_tr_sscav,d_tr_sat,d_tr_uscav,qDi,qPr, &
-            qPa,qMel,qTrdi,dtrcvMA,Mint,                            &
-            zmfd1a,zmfphi2,zmfdam)
-!           ENDIF
-!
-!           IF (.FALSE.) THEN 
-!           CALL cvltr(pdtphys, da, phi,phi2,d1a,dam, mp,ep,
-!     .       sigd,sij,wght_cvfd,clw,elij,epmlmMm,eplaMm,
-!     .       pmflxr,pmflxs,evapls,t_seri,wdtrainA,wdtrainM,
-!     .       paprs,itr,tmp_var3,upwd,dnwd,itop_con,ibas_con,
-!     .       d_tr_cv,d_tr_trsp,d_tr_sscav,d_tr_sat,d_tr_uscav,qDi,qPr,
-!     .       qPa,qMel,qTrdi,dtrcvMA,Mint,
-!     .       zmfd1a,zmfphi2,zmfdam)
-!!  pas lessivage convectif pou n'est pas un aerosol (i/else with cvltr)
-!           ENDIF
-
-
-
-!!!!!!!         CALL cvltrorig(it,pdtphys, da, phi,mp,paprs,pplay,tr_seri,
-!!!         CALL cvltrorig(it,pdtphys, da, phi,mp,paprs,pplay,tmp_var3,
-!!!     .               upwd,dnwd,d_tr_cv)
-!             print *,'justbefore cvltrnoscav it= ',it
-!             CALL checknanqfi(da(:,:),1.,-1.,' da')
-!             CALL checknanqfi(wght_cvfd(:,:),1.,-1.,'weigth ')
-!             CALL checknanqfi(mp(:,:),1.,-1.,'mp ')
-!             CALL checknanqfi(paprs(:,:),1.,-1.,'paprs ')
-!             CALL checknanqfi(pplay(:,:),1.,-1.,'pplay ')
-!             CALL checknanqfi(tmp_var3(:,:,itr),1.,-1.,'tmp_var3 ')
-!             CALL checknanqfi(upwd(:,:),1.,-1.,'upwd ')
-!             CALL checknanqfi(dnwd(:,:),1.,-1.,'dnwd ')
-!             CALL checknanqfi(d_tr_cv(:,:,itr),1.,-1.,'d_tr_cv ')
-!             IF (.TRUE.) THEN
-!             CALL cvltr_noscav(it,pdtphys, da, phi,mp,wght_cvfd,paprs,
-!     .            pplay,tmp_var3,upwd,dnwd,d_tr_cv)
-!             ENDIF
-             DO k = 1, klev
-              DO i = 1, klon
-!               tr_seri(i,k,itr) = tr_seri(i,k,itr) + d_tr_cv(i,k,itr)
-               tr_seri(i,k,itr)=(tmp_var3(i,k,itr)+d_tr_cv(i,k,itr))
-               tmp_var(i,k)=d_tr_cv(i,k,itr)
-
-              END DO
-             END DO
-
-        CALL kg_to_cm3(pplay,t_seri,tmp_var) !just for his_* computation
-
-             DO k = 1, klev
-              DO i = 1, klon
-               dtrconv(i,itr)=0.0
-               his_dhkecv(i,itr)=his_dhkecv(i,itr)-tmp_var(i,k)  &
-                     /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys
-              END DO
-             END DO
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        CALL kg_to_cm3(pplay,t_seri,tmp_var) !just for his_* computation
-
-             DO k = 1, klev
-              DO i = 1, klon
-               dtrconv(i,itr)=0.0
-               his_ds(i,itr)=his_ds(i,itr)-tmp_var(i,k)  &
-                     /RNAVO*masse(itr)*1.e3*1.e6*zdz(i,k)/pdtphys
-              END DO
-             END DO
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-       IF (lminmax) THEN
-
-         print *,'Check sum after cvltr itr)',itr,SUM(tr_seri(:,:,itr))
-        CALL minmaxqfi2(d_tr_cv(:,:,itr),qmin,qmax,'d_tr_cv:')
-        CALL minmaxqfi2(d_tr_trsp(:,:,itr),qmin,qmax,'d_tr_trsp:')
-        CALL minmaxqfi2(d_tr_sscav(:,:,itr),qmin,qmax,'d_tr_sscav:')
-        CALL minmaxqfi2(d_tr_sat(:,:,itr),qmin,qmax,'d_tr_sat:')
-        CALL minmaxqfi2(d_tr_uscav(:,:,itr),qmin,qmax,'d_tr_uscav:')
-      IF (lcheckmass) THEN
-        CALL checkmass(d_tr_cv(:,:,itr),RNAVO,masse(itr),zdz,  &
-           pplay,t_seri,.false.,'d_tr_cv:')
-      ENDIF
-       ENDIF
-         ENDDO ! it=1,nbtr
-
-        ENDIF ! iflag_conv
-       IF (lminmax) THEN
-        DO itr=1,nbtr
-        CALL checknanqfi(tr_seri(:,:,itr),qmin,qmax,'nan_after_trcon')
-        ENDDO
-        DO itr=1,nbtr
-        CALL minmaxqfi2(tr_seri(:,:,itr),qmin,qmax,'after trconv')
-        ENDDO
-      IF (lcheckmass) THEN
-        DO itr=1,nbtr
-         CALL checkmass(tr_seri(:,:,itr),RNAVO,masse(itr),zdz, &
-           pplay,t_seri,iscm3,'after trconv')
-        ENDDO
-      ENDIF
-        CALL minmaxsource(source_tr,qmin,qmax,'src: after trconv')
-      ENDIF
-      ENDIF ! convection
-
-      IF (logitime) THEN
-      CALL SYSTEM_CLOCK(COUNT=clock_end)
-      dife=clock_end-clock_start
-      ti_cvltr=dife*MAX(0,SIGN(1,dife))   &
-      +(dife+clock_per_max)*MAX(0,SIGN(1,-dife))
-      tia_cvltr=tia_cvltr+REAL(ti_cvltr)/REAL(clock_rate)
-      ENDIF
-
-
-
-!
-!
-!=======================================================================
-!      LARGE SCALE SCAVENGING KE
-!=======================================================================
-!     
+    ENDIF ! convection
+
+    IF (logitime) THEN
+      CALL SYSTEM_CLOCK(COUNT = clock_end)
+      dife = clock_end - clock_start
+      ti_cvltr = dife * MAX(0, SIGN(1, dife))   &
+              + (dife + clock_per_max) * MAX(0, SIGN(1, -dife))
+      tia_cvltr = tia_cvltr + REAL(ti_cvltr) / REAL(clock_rate)
+    ENDIF
+
+
+    !=======================================================================
+    !      LARGE SCALE SCAVENGING KE
+    !=======================================================================
+
 #ifdef IOPHYS_DUST
       call iophys_ecrit('da',klev,'da','',da)
